//  ?-??-97    Adam Cutchin-
//             Made it delphi 3 compliant.  Fixed some bugs.  Made it use
//             hooks instead of keypreview events to monitor for the hotkey.

//  8-22-96    Adam Cutchin-
//             Fixed the bizzare bug where it crashes the whole system when
//             you drag the split in the inspector window past the right edge
//             of the window.

//  8-26-96    Adam Cutchin-
//             Made it poll five times per second to update the values.  Not
//             by a timer, but with the onIdle handler.  Doesn't take up
//             enough processor time in WinNT to evern show 1% cpu usage.

//  8-27-96    Adam Cutchin-
//             When the inspector is vertically resized, it makes sure there
//             isn't a line in the listbox partially showing by rounding
//             the size to Listbox.itemheight.

//  9-17-95    Adam Cutchin-
//             You can now double click on the right side of a property, and
//             it behaves like Delphi's.  (It toggles it, if boolean, steps
//             through available options if its enumerated.)  Don't have
//             property editors yet.

//  9-18-96    Adam Cutchin-
//             It waits to expand children of the application until you
//             try to drop it down.  (Makes it start up much quicker in a
//             large applicatiion.)

//  9-19-96    Adam Cutchin-
//             Property editors.  Cool.

// 10-22-96    Adam Cutchin-
//             You can specify the DLL path.  Defaults to n:\test\paslib\inspect

unit Inspect;

interface

{.$Define Shareware }


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, TypInfo, InspUtil, Menus, DB, ExtCtrls, ComCtrls, StdCtrls, Buttons;


Type tShowEvent = Procedure(Sender : Tobject;  var CanShow : Boolean) of Object;

Type PropEdType = (peProp, peSetItem);

Type TPropEditData = Record
    Kind : PropEdType;
   Depth : Integer;
      Ob : TObject;
      PI : PPropInfo;
   LastS : String[75];
  Case PropEdType of
    peSetItem : (Value : LongInt;
                 Name  : ShortString);
    peProp : (PropData     : PPropInfo;
              ChildShowing : Boolean);
End;

Type TEventData = Record
  O : TObject;
  M : TMethod;
  Enabled : Boolean;
  PI : PPropInfo;
  Count : Integer;
End;

Type PChangedEvent = ^ChangedEvent;
     ChangedEvent = Record
       O    : Tobject;
       Data : TEventData;
       Next : PChangedEvent;
     End;

type PEventData = ^TEventData;

Type PPropEditData = ^TPropEditData;

type
  Tf_Inspector = class(TForm)
    TreeView1: TTreeView;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ListBox2: TListBox;
    ListBox1: TListBox;
    PaintBox1: TPaintBox;
    Edit1: TEdit;
    Button1: TSpeedButton;
    Label1: TLabel;
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FormCreate(Sender: TObject);
    procedure ListBox2DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormResize(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ListBox2DblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit1Exit(Sender: TObject);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormHide(Sender: TObject);
    procedure Edit1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TreeView1Expanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure TreeView1Collapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure ListBox2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TreeView1DblClick(Sender: TObject);
    { Private declarations }
  public
    ComboButtonBox : Trect;
    CBDown : Boolean;
    ImageL : TImageList;
    HotKey : tShortCut;
    Autostarted : Boolean;
    BeforeShow : tShowEvent;
    Ti : TComponent;
    procedure AutoStart;
    Procedure EndAutoStart;
    Constructor create(parent : tcomponent{;  TTI : tObject}); Override;
    procedure InsertComp(C, Parent : TComponent);
    procedure SelectComp(C : TComponent);
  private
    OldFormHandler : TNotifyEvent;
    OldKeyEvent : TkeyEvent;
    OldKeyPreview : Boolean;
    OldIdleHandler : TIdleEvent;
    TreeIList : TStringList;
    Lastpoll : Real;
    LastForm : TForm;
    DownArrow : TBitmap;
    MDX : Integer;
    EditRect : TRect;
    HalfWay : Integer;
    SplitDrag : Boolean;
    LastEdit : TRect;
    LastX : Integer;
    EditHit : Real;
    FromListBox : Boolean;
    LastException : String[255];
    parentObject : tcomponent;
    Function LocateComp(C : TComponent) : ttreeNode;
    Procedure NewFormhandler(Sender : TObject);
    Function AssignIcon(O : TObject) : Integer;
    Procedure ShowChildren(O : TComponent;  I : TTreeNode);
    Procedure ShowAll(I : TTreeNode);
    Procedure NewKeyEvent(Sender : TObject; Var Key : Word; Shift : TShiftState);
    Procedure Idlehandler(Sender : TObject; var Done : Boolean);
    Procedure WhileSizing(Var msg : tmessage);  Message WM_SIZING;
    Function SeeIfChanged(X : Integer) : Boolean;
  published
    { Public declarations }
  end;


var
  ChangedEvents : PChangedEvent;

  Counters : Array[0..255] of Integer;
  IPs      : Array[0..255] of Integer;

implementation

uses ListPop, PropEd, RegInsp
{$IFDEF Shareware}
, PropList
{$ENDIF }
;

Const UnAssignedEvent : TMethod = ();

const maxObjects : Integer = 0;

{$R *.DFM}


var hookedInspector : Tf_Inspector;
    hHook : tHandle;


            { Places all components in their proper place in the treeview. }
Procedure Tf_Inspector.ShowChildren(O : TComponent;  I : TTreeNode);
var x,y : Integer;
    t : TTreeNode;
    Si: Integer;
    S : String;
    tempT : TTreeNode;
    b : boolean;
Begin
               { Place fields as children of their dataset. }
{$IFDEF Shareware}
if TreeView1.items.Count > maxobjects then exit;
{$ENDIF }

if assigned((ti as tInspector).OnFilterObject) then begin
  b := true;
  (ti as tInspector).OnFilterObject(O, b);
  if not b then exit;
end;

  If O is TDataSet then
  With O as TDataset do
    For x:= 0 to FieldCount-1 do Begin
      S := Fields[x].Name;

      If Pos(O.Name, S) <> 0 then System.Delete(S,Pos(O.Name, S), Length(O.Name));
      t := TreeView1.Items.AddChildObject(I, S, Fields[x]);
      si := TreeIList.IndexOf('TFIELD');
    t.imageIndex := si;
    t.SelectedIndex := si;
  End;

                       { Get menus - they are a special case. }
  If (O is TMainMenu) or (O is TpopUpMenu) then
    For y := 0 to O.Owner.ComponentCount-1 do
      if (o.Owner.components[Y] is TMenuItem) and
         ((o.Owner.components[Y] as TmenuItem).getparentComponent = o) then Begin
        t := TreeView1.Items.AddChildObject(I, o.Owner.components[y].Name,
                                                               o.Owner.components[y]);
        SI := AssignIcon(o.Owner.Components[y]);
        SI := AssignIcon(o);      // This really shouldn't work.
        T.imageIndex := si;
        T.SelectedIndex := si;
        ShowChildren(o.Owner.Components[y], T);
{$IFDEF Shareware}
if TreeView1.items.Count > maxobjects then exit;
{$ENDIF }
      End;

{$IFDEF Shareware}
if TreeView1.items.Count > maxobjects then exit;
{$ENDIF }


          { First get non visual components. }
  For x := 0 to O.ComponentCount-1 Do Begin
    If Not ((o.components[x] is TWinControl) or (o.components[x] is TInspector)) then Begin
              { Get everything else. }
      If not ((o.components[x] is tField) or (o.components[x] is TMenuItem))
          or (o.components[x] is TInspector) then Begin
      t := TreeView1.Items.AddChildObject(I, o.components[x].Name,
                                                   o.components[x]);
      SI := AssignIcon(o.Components[x]);
      t.imageIndex := si;
      t.SelectedIndex := si;
    ShowChildren(o.components[x], T);
{$IFDEF Shareware}
if TreeView1.items.Count > maxobjects then exit;
{$ENDIF }
    End;
  End;
End;

{$IFDEF Shareware}
if TreeView1.items.Count > maxobjects then exit;
{$ENDIF }

              { TMenuItems store children in Items, not Components }
  If O is TMenuItem then
  With O as TmenuItem do
    For x := 0 to Count - 1 do Begin
      t := TreeView1.Items.AddChildObject(I, Items[x].Name,
                                                   Items[x]);
      si := TreeIList.IndexOf('TMENU');
      t.imageIndex := si;
      t.SelectedIndex := si;
      ShowChildren(Items[x], T);
{$IFDEF Shareware}
if TreeView1.items.Count > maxobjects then exit;
{$ENDIF }
    End;

{$IFDEF Shareware}
if TreeView1.items.Count > maxobjects then exit;
{$ENDIF }

              { to preserve visual hierarchy. }
  If O is TWinControl then
  With O as TWincontrol do
  For x := 0 to ControlCount-1 Do
    If (controls[x] is TWinControl) then Begin
      t := TreeView1.Items.AddChildObject(I, controls[x].Name,
                                                   controls[x]);
      SI := AssignIcon(Controls[x]);
      t.imageIndex := si;
      t.SelectedIndex := si;
      ShowChildren(controls[x], T);
{$IFDEF Shareware}
if TreeView1.items.Count > maxobjects then exit;
{$ENDIF }
    End;

{$IFDEF Shareware}
if TreeView1.items.Count > maxobjects then exit;
{$ENDIF }

End;
               { Creates a item in the treeview for each form in application. }
Procedure Tf_Inspector.ShowAll(I : TTreeNode);
var X : Integer;
    t : TTreeNode;
    Si: Integer;
    b : boolean;
Begin
  With Parentobject do
  For X := 0 to ComponentCount-1 do Begin
    If (components[x].ClassType <> tf_Inspector) and
       (components[x].ClassType <> tListScreen) and
       (components[x].ClassType <> thintWindow) and
       (components[x].ClassType <> tInspector) then Begin
        if assigned((ti as tInspector).OnFilterObject) then begin
          b := true;
          (ti as tInspector).OnFilterObject(components[x], b);
          if b then begin
            t := TreeView1.Items.AddChildObject(I, components[x].Name, components[x]);
            SI := AssignIcon(Components[x]);
            t.imageIndex := si;
            t.SelectedIndex := si;
            If Components[x].ComponentCount > 0 then
            TreeView1.Items.AddChild(T, 'Dummy12345');
          End;
        end else begin
            t := TreeView1.Items.AddChildObject(I, components[x].Name, components[x]);
            SI := AssignIcon(Components[x]);
            t.imageIndex := si;
            t.SelectedIndex := si;
            If Components[x].ComponentCount > 0 then
            TreeView1.Items.AddChild(T, 'Dummy12345');
          End;
      End;
    End;
End;
                 { Like 'is,' but works with a string. }
Function IsA(PI : PTypeInfo; S : String) : Boolean;
Var PTD : PTypeData;
    PTI : PTypeInfo;
    Found : Boolean;
Begin
  Found := False;
  S := UpperCase(S);
  PTI := PI;
  While (Not Found) and (UpperCase(PTI^.Name) <> 'TOBJECT') do Begin
    Found := UpperCase(PTI^.Name) = S;
    PTD := GetTypeData(PTI);
    PTI := PTD^.ParentInfo^;
  End;
  IsA := Found;
End;
                    { Traces up the inheritance Hierarchy to assign icons to }
                                                               { components. }
Function Tf_Inspector.AssignIcon(O : TObject) : Integer;
Var IconIndex : Integer;
    PTD : PTypeData;
    PTI : PTypeInfo;
    Begin
    IconIndex := TreeIList.Indexof(O.ClassName);
      if IconIndex = -1 then Begin
        PTI := O.ClassInfo;
        While (IconIndex = -1) and (UpperCase(PTI^.Name) <> 'TOBJECT') do Begin
          PTD := GetTypeData(PTI);
          PTI := PTD^.ParentInfo^;
          IconIndex := TreeIList.IndexOf(UpperCase(PTI^.Name));
        End;
      End;
      If IconIndex = -1 then IconIndex := TreeIList.IndexOf('TUNKNOWN');

AssignIcon := IconIndex;
End;
            { I don't remember much about these.  They allow for enabling and }
                                                       { disabling of events. }
Function FindEvent(O : TObject; PI : PPropInfo) : PChangedEvent;
Var CE : PChangedEvent;
Begin
 CE := ChangedEvents;
 While (CE <> Nil) and ((CE^.O <> o) and (CE^.Data.PI <> PI)) do
   CE := cE^.next;
 If (ce <> nil) then if ((CE^.O <> o) or (CE^.Data.PI <> PI)) then CE := Nil;
 FindEvent := CE;
End;

Procedure DeleteEvent(O : TObject; PI : PPropInfo);
Var CE, Last : PChangedEvent;
begin
 CE := ChangedEvents;
 Last := CE;
 If CE^.Next = Nil then begin
   If (CE^.O = o) and (CE^.Data.PI = PI) then Begin
     FreeMem(CE, SizeOf(ChangedEvent));
     ChangedEvents := Nil;
   End;
   Exit;
 End;
 While (CE <> Nil) and ((CE^.O <> o) and (CE^.Data.PI <> PI)) do Begin
   Last := CE;
   CE := cE^.next;
 End;
 If CE <> Nil then Begin
   If CE = ChangedEvents then ChangedEvents := CE^.Next;
   Last^.next := CE^.next;
   FreeMem(CE, SizeOf(ChangedEvent));
 End;
End;

Procedure AddEvent(O : TObject; Pi : PPropInfo; D : TEventData);
var CE : PChangedEvent;
Begin
CE := ChangedEvents;
If ce = nil then begin
  GetMem(CE, Sizeof(ChangedEvent));
  ChangedEvents := CE;
End else begin
  While (CE^.Next <> Nil) do CE:= CE^.Next;
  Begin
    GetMem(CE^.Next, Sizeof(ChangedEvent));
    CE := CE^.next;
  End;
End;
CE^.O := O;
CE^.Data := D;
CE^.Data.PI := PI;
CE^.Next := Nil;
End;
     { This enumerates each property and puts them in the list box. }
procedure Tf_Inspector.TreeView1Change(Sender: TObject; Node: TTreeNode);
var C : TComponent;
    PL: PPropList;
    Size : Integer;
    X : Integer;
    PPED : PPropEditData;
    PED  : PEventData;
    b : boolean;
begin
  If Edit1.Focused then listBox1.SetFocus;
  Button1.Visible := false;
  For X := 0 to ListBox1.Items.Count - 1 do
    FreeMem(Pointer(ListBox1.Items.Objects[X]), SizeOf(TPropEditData));

  For X := 0 to ListBox2.Items.Count - 1 do
    FreeMem(Pointer(ListBox2.Items.Objects[X]), SizeOf(TEventData));

  ListBox1.Items.Clear;
  ListBox2.Items.Clear;

C := TComponent(Treeview1.Selected.Data);

Try
  Size := GetTypeData(C.Classinfo)^.Propcount;
  ListBox1.Visible := True;
Except
  ListBox1.Visible := False;
  Exit;
End;

  GetMem(PL, Size*SizeOf(Pointer));

  GetPropInfos(c.ClassInfo, PL);
//  GetPropList(c.ClassInfo, tkAny, PL);

  if C.name <> '' then
    Caption := C.Name + ' : ' + C.Classname
  else Caption := 'UNNAMED : ' + C.Classname;

  for X := 0 to Size-1 do
  if pl[x] <> nil then
  if pl[x]^.proptype^.kind <> tkMethod then
  Begin
    GetMem(PPED, SizeOf(TPropEditData));
    PPED^.Ob := C;
    PPED^.PI := @pl[x]^.PropType;
    PPED^.Kind := peProp;
    PPED^.ChildShowing := False;
    PPED^.Depth := 0;
    PPED^.PropData := pl[x];

    if assigned((ti as tInspector).OnFilterProperty) then begin
      b := true;
{      peProp :    TextRect(SR, Sr.Left, SR.Top, S + PI^.Name);
      peSetItem : TextRect(SR, Sr.Left, SR.Top, S + PPED^.Name);
}      (ti as tInspector).OnFilterProperty(C, pped^.pi^.name, b);
      if b then SeeIfChanged(ListBox1.Items.AddObject('', TObject(PPED)));;
    end else
      SeeIfChanged(ListBox1.Items.AddObject('', TObject(PPED)));
  End
  else
  Begin
    GetMem(PED, SizeOf(TEventData));

    PED^.Enabled := (FindEvent(C, pl[x]) = Nil);

    If Not PED^.Enabled then begin
      PED^.M := FindEvent(C, PL[x])^.Data.M;
    end else
    PED^.M := GetMethodProp(C, pl[x]);

    PED^.O := C;
    PED^.PI := @pl[x]^.PropType;
    ListBox2.Items.AddObject('', TObject(PED));
  End;

  FreeMem(PL, Size * SizeOf(Pointer));
end;

Constructor tf_inspector.create(parent : tcomponent);
begin
  inherited;
  FormCreate(Nil);
//  self := tF_inspector(tform{(self)}.create(Nil));
//  ti := tcomponent(TTI);
//  formcreate(Nil);
end;
          { this loads bitmaps from DLL among other things. }
procedure Tf_Inspector.FormCreate(Sender: TObject);
var X,y : Integer;
    P : TPicture;
    ExeFile : TExeImage;
    b : tbitmap;
begin
  Ti := Owner;
  Autostarted := false;
  BeforeShow := nil;
  HotKey := ShortCut(vk_end, [ssCtrl, ssAlt]);
  CBDown := False;
  Edit1.Parent := ListBox1;
  Button1.Parent := ListBox1;
  listScreen := TListScreen.Create(Self);
  UnAssignedEvent.Code := Nil;
  UnAssignedEvent.Data := Nil;
  ChangedEvents := Nil;
  MDX := -1;
  TreeIList := TStringList.Create;
if Assigned(TI) then
  if FileExists((TI as tInspector).Dllpath + '\' + 'Icons.dll') then begin
    P := TPicture.Create;
    ImageL := TImagelist.Create(Self);
    TreeView1.Images := ImageL;
    TreeView1.Images.Height := (TI as tInspector).IconSize;
    TreeView1.Images.Width := (TI as tInspector).IconSize;
    ExeFile := TExeImage.Create(Self, (TI as tInspector).Dllpath + '\' + 'Icons.dll');
    For X := 0 to ExeFile.Resources.Count-1 do
      if ExeFile.Resources.Items[x].IsList then Begin
        for y := 0 to ExeFile.Resources.Items[x].list.Count-1 do
          if ExeFile.Resources.Items[x].list.Items[y] is TBitmapResource then
            if ExeFile.Resources.Items[x].List.Items[Y].Name[1] = 'T' then
              Begin
                P.Assign(ExeFile.Resources.Items[x].List.Items[y]);
                If (P.Width <= 36) and (p.Height <= 36) then Begin
                  b := tbitmap.create;
                  SetStretchBltmode(B.Canvas.Handle, ColorOnColor);
                  B.width := (TI as tInspector).IconSize;
                  B.height := (TI as tInspector).IconSize;
                  B.canvas.StretchDraw(B.canvas.clipRect, p.bitmap);
                  TreeView1.Images.AddMasked(b, clOlive);
                  TreeIList.Add(ExeFile.Resources.Items[x].List.Items[Y].Name);
                  B.free;
                End;
              End;
      End;
    ExeFile.Free;
    P.Free;
  End;

  P := TPicture.Create;
  ExeFile := TExeImage.Create(Self, Application.ExeName);
  For X := 0 to ExeFile.Resources.Count-1 do
    if ExeFile.Resources.Items[x].IsList then Begin
      for y := 0 to ExeFile.Resources.Items[x].list.Count-1 do
        if ExeFile.Resources.Items[x].list.Items[y] is TBitmapResource then
          if ExeFile.Resources.Items[x].List.Items[Y].Name[1] = 'T' then
            Begin
              P.Assign(ExeFile.Resources.Items[x].List.Items[y]);
              If (P.Width <= 36) and (p.Height <= 36) then Begin
                b := tbitmap.create;
                SetStretchBltmode(B.Canvas.Handle, ColorOnColor);
                B.width := (TI as tInspector).IconSize;
                B.height := (TI as tInspector).IconSize;
                B.canvas.StretchDraw(B.canvas.clipRect, p.bitmap);
                TreeView1.Images.AddMasked(b, clOlive);
                TreeIList.Add(ExeFile.Resources.Items[x].List.Items[Y].Name);
                B.free;
              End;
            End;
    End;
  ExeFile.Free;
  P.Free;

  DownArrow := tBitmap.Create;
  DownArrow.Width := 7;
  DownArrow.Height := 4;
  DownArrow.canvas.Brush.Color := clBtnFace;
  DownArrow.canvas.Pen.Color := clBtnface;
  DownArrow.Canvas.Rectangle(0,0,7,4);
  DownArrow.Canvas.Pen.Width := 0;
  DownArrow.Canvas.pen.Color := clBlack;
  DownArrow.Canvas.MoveTo(0, 0);
  DownArrow.Canvas.LineTo(7, 0);
  DownArrow.Canvas.MoveTo(1, 1);
  DownArrow.Canvas.LineTo(6, 1);
  DownArrow.Canvas.MoveTo(2, 2);
  DownArrow.Canvas.LineTo(5, 2);
  DownArrow.Canvas.Pixels[3, 3] := clBlack;
End;


           { Draws event names and shows if their assigned.  }
procedure Tf_Inspector.ListBox2DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
Var PED : PEventData;
    SR, DR : Trect;
begin
  PED := Pointer(ListBox2.Items.Objects[Index]);
  With (Control as TListBox).Canvas do
  Begin
    Brush.Color := ListBox1.Color;          {Won't use Windows Selected color.}
    fillRect(rect);

    If (odSelected in State) then Pen.Color := clBtnHighLight else {for 3D look}
      Pen.Color := clBtnShadow;
    Pen.Mode := pmCopy;
    Pen.Width := 1;
    Pen.Style := psSolid;
    MoveTo(rect.Left, Rect.Bottom-1);
    LineTo(rect.Right, Rect.Bottom-1);

    If (odSelected in State) then Begin

    Pen.Color := clBtnHighLight;
    MoveTo(HalfWay + 2, Rect.Top+1);
    LineTo(Halfway + 2, Rect.Bottom);

      Pen.Color := clBtnShadow;
      MoveTo(Halfway+1, rect.Top+2);
      LineTo(Halfway+1, rect.Bottom);

      MoveTo(Rect.Right, Rect.Top);
      LineTo(Rect.Left, Rect.Top);
      LineTo(Rect.Left, Rect.Bottom);

      Pen.Color := clBlack;
      MoveTo(Rect.Right-1, Rect.Top+1);
      LineTo(Rect.Left+1, Rect.Top+1);
      LineTo(Rect.Left+1, Rect.Bottom-1);
    End Else Begin
      Pen.Color := clBtnShadow;
      MoveTo(Halfway, rect.Top+1);
      LineTo(Halfway, rect.Bottom);

    Pen.Color := clBtnHighLight;
    MoveTo(HalfWay + 1, Rect.Top+1);
    LineTo(Halfway + 1, Rect.Bottom);
    End;


    SR.Left := Rect.Left + 16;  SR.Right := HalfWay;
    SR.Top := Rect.Top+1;  SR.Bottom := Rect.Bottom-1;

    If (odSelected in State) then Begin
      Inc(SR.Left);
      Inc(SR.Top);
      Inc(SR.Right);
    End;
      Font.Color := clBlack;
      setbkMode(ListBox2.Canvas.Handle, Transparent);
      TextRect(SR, Sr.Left, SR.Top, PED^.PI^.Name);


//    SR.Left := 0;  SR.Right := ImageList1.width;  {SourceRect, for Copyrect function.}
//    SR.Top := 0; SR.Bottom := ImageList1.height;  { (for the checkbox.)  }

    DR.Left := Rect.Left+2;  DR.Right := Rect.Left+13+2;  {DestRect}
    DR.Top := Rect.Top+1; DR.Bottom := Rect.Top+13+1;

    If (odSelected in State) then Begin       { To give 3D look to inspector.}
      Inc(DR.Left); Inc(DR.Right);
      Inc(DR.Top); Inc(DR.Bottom);
    End;

//    pen.Color := clBtnFace;
    Font.Color := clNavy;


    if PED^.M.Code <> Nil then begin

      if PED^.Enabled then
        DrawFrameControl((Control as TListBox).Canvas.handle, Dr, dfc_Button,
          dfcs_buttonCheck or dfcs_checked)
//        ImageList1.Draw((Control as TListBox).Canvas, Dr.left, dr.top, 3)
      else
        DrawFrameControl((Control as TListBox).Canvas.handle, Dr, dfc_Button,
          dfcs_buttonCheck{ or dfcs_checked})

//      ImageList1.Draw((Control as TListBox).Canvas, dr.left, dr.Top, 2)
    end else
        DrawFrameControl((Control as TListBox).Canvas.handle, Dr, dfc_Button,
          dfcs_buttonCheck or dfcs_inactive);
//      imagelist1.Draw((Control as TListBox).Canvas.handle, Dr.Left, Dr.Top, 1);



{      if PED^.Enabled then
      CopyRect(DR, cbf.Canvas, Sr) Else CopyRect(DR, cbe.Canvas, Sr);
    End Else
      CopyRect(DR, cbd.Canvas, Sr);
}

      if odSelected in State then
        if ped^.m.code <> nil then
        TextOut(HalfWay + 4, Rect.Top+1, 'Assigned') else
        TextOut(HalfWay + 4, Rect.Top+1, 'Unassigned')
      Else
        if ped^.m.code <> nil then
        TextOut(HalfWay + 3, Rect.Top, 'Assigned') else
        TextOut(HalfWay + 3, Rect.Top, 'Unassigned');


{    if PED^.M.Code <> Nil then begin
      if PED^.Enabled then
      CopyRect(DR, cbf.Canvas, Sr) Else CopyRect(DR, cbe.Canvas, Sr);
      if odSelected in State then
        TextOut(HalfWay + 4, Rect.Top+1, 'Assigned')
      Else
       TextOut(HalfWay + 3, Rect.Top, 'Assigned');
    End Else
      CopyRect(DR, cbd.Canvas, Sr);
}
    if (odFocused in State) and (odselected in state) then
      DrawFocusRect(rect);
  End;
end;



procedure Tf_Inspector.FormDestroy(Sender: TObject);
begin
unHookWindowsHookEx(hHook);
If Assigned(DownArrow) then DownArrow.Free;
//EndAutoStart;
If Assigned(ImageL) then ImageL.Free;
If Assigned(TreeIList) then TreeIList.Free;
end;
                  { Looks to see if the memorized property is the right one. }
                { this is only really used to prevent flicker while polling. }
Function Tf_Inspector.SeeIfChanged(X : Integer) : Boolean;
var C : TObject;
Var PI : PPropInfo;
var RString : string;
    PPED : PPropEditData;
    V : Integer;
    O : TObject;
Begin
  PPED := Pointer(ListBox1.Items.Objects[X]);
  C := PPED^.Ob;
  try
  if PPED^.Kind = peProp then begin
    PI := PPED^.PropData;
  If PPED^.Kind = peProp then
  begin
  If C <> Nil then
    case PI^.Proptype^.Kind of
      tkInteger, tkChar: Rstring := IntToStr(GetOrdProp(C, PI));
      tkSet : RString := '(Set...)';
      tkEnumeration :
      Begin
        V := GetOrdProp(C, PI);
        RString := GetEnumName(PI^.PropType^, V);
      End;

     tkFloat : RString := FloatToStrf(GetFloatProp(C, PI), ffnumber, 5, 10);

     tkString, tkLString: RString := getStrProp(C, PI);
     tkClass: Begin
       O := TObject(GetOrdProp(C, PI));
       If Assigned(O) and (O is TComponent) then RString := TComponent(O).Name else
         Rstring := GetTypeData(PI^.Proptype^)^.ClassType.classname;
       If Not Assigned(O) then RString := RString + ' (Nil.)';
     End;
    End;
  End;


  If PPED^.Kind = peSetItem then
  if (GetOrdProp(PPropEditData(PPED^.Ob)^.Ob, PPED^.PI) and (1 shl PPED^.Value)) >= 1 then
    RString := 'True' Else RString := 'False';
End;
  except rstring := '**Exception**';
end;

Result :=  PPED^.LastS <> RString;
PPED^.LastS := RString;
End;
            { I'm really sorry about these next two procedures.  I'm too busy }
                                       { right now do document them properly. }
procedure Tf_Inspector.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
Var PI : PPropInfo;
var C : TObject;
    EdString, RString: String;
    V : Integer;
    PPED : PPropEditData;
    S : String;
    O : TObject;
    SR : TRect;
    DR, R1 : TRect;
begin
  PPED := Pointer(ListBox1.Items.Objects[Index]);
      HideCaret(ListBox1.Handle);
  //  C := TControl(Treeview1.Selected.Data);
  C := PPED^.Ob;
  S := '';

  For V := 0 to PPED^.Depth do
    S := S + '  ';

  if PPED^.Kind = peProp then begin
    PI := PPED^.PropData;
    If PI^.PropType^.kind in [tkSet, tkClass] then
      If (PI^.PropType^.kind = tkClass) then Begin
        S := Copy(S, 1, Length(S) - 2);
        if IsA(PI^.PropType^, 'TCOMPONENT') then
          S := S + '  '
        else if PPED^.ChildShowing then
        S := S + '- ' else s := s + '+'
      End Else Begin
          S := Copy(S, 1, Length(S) - 2);
          if PPED^.ChildShowing then
          S := S + '- '
        Else S := S + '+';
    End;
  End;

  With (Control as TListBox).Canvas do
  Begin
    Brush.Color := ListBox1.Color;          {Won't use Windows Selected color.}
    sr := rect;
    If odselected in state then sr.Right := halfway;
    fillRect(sr);

    If (odSelected in State) then Pen.Color := clBtnHighLight else {for 3D look}
      Pen.Color := clBtnShadow;
    Pen.Mode := pmCopy;
    Pen.Width := 1;
    Pen.Style := psSolid;
    MoveTo(rect.Left, Rect.Bottom-1);
    LineTo(rect.Right, Rect.Bottom-1);


    If (odSelected in State) then Begin

    Pen.Color := clBtnHighLight;
    MoveTo(HalfWay + 2, Rect.Top+1);
    LineTo(Halfway + 2, Rect.Bottom);

      Pen.Color := clBtnShadow;
      MoveTo(Halfway+1, rect.Top+2);
      LineTo(Halfway+1, rect.Bottom);

      MoveTo(Rect.Right, Rect.Top);
      LineTo(Rect.Left, Rect.Top);
      LineTo(Rect.Left, Rect.Bottom);

      Pen.Color := clBlack;
      MoveTo(Rect.Right-1, Rect.Top+1);
      LineTo(Rect.Left+1, Rect.Top+1);
      LineTo(Rect.Left+1, Rect.Bottom-1);
    End Else Begin
      Pen.Color := clBtnShadow;
      MoveTo(Halfway, rect.Top+1);
      LineTo(Halfway, rect.Bottom);

    Pen.Color := clBtnHighLight;
    MoveTo(HalfWay + 1, Rect.Top+1);
    LineTo(Halfway + 1, Rect.Bottom);
    End;

    SR.Left := Rect.Left;  SR.Right := HalfWay;
    SR.Top := Rect.Top+1;  SR.Bottom := Rect.Bottom-1;
    Font.Color := clBlack;

    If (odSelected in State) then Begin
      Inc(SR.Left);
      Inc(SR.Top);
      Inc(SR.Right);
    End;

    setbkMode(ListBox1.Canvas.Handle, Transparent);

    Case PPED^.Kind of
      peProp :    TextRect(SR, Sr.Left, SR.Top, S + PI^.Name);
      peSetItem : TextRect(SR, Sr.Left, SR.Top, S + PPED^.Name);
    End;

    pen.Color := clBtnFace;
    Font.Color := clNavy;

  End;

  try
  If PPED^.Kind = peProp then
  begin
  If C <> Nil then
    case PI^.Proptype^.Kind of
      tkInteger, tkChar: Rstring := IntToStr(GetOrdProp(C, PI));
      tkSet : RString := '(Set...)';
      tkEnumeration :
      Begin
        V := GetOrdProp(C, PI);
        RString := GetEnumName(PI^.PropType^, V);
      End;

     tkFloat : RString := FloatToStrf(GetFloatProp(C, PI), ffnumber, 5, 10);

     tkString, tkLString: RString := getStrProp(C, PI);
     tkClass: Begin
       O := TObject(GetOrdProp(C, PI));
       If Assigned(O) and (O is TComponent) then RString := TComponent(O).Name else
         Rstring := GetTypeData(PI^.Proptype^)^.ClassType.classname;
       If Not Assigned(O) then RString := RString + ' (Nil.)';
     End;
    End;
  End;

  If PPED^.Kind = peSetItem then
  Begin
  if (GetOrdProp(PPropEditData(PPED^.Ob)^.Ob, PPED^.PI) and (1 shl PPED^.Value)) >= 1 then
    RString := 'True' Else RString := 'False';
  End;
  except rstring := '**Exception**';
  End;

  PPED^.LastS := rstring;

  (Control as TListbox).Canvas.Font.Color := clNavy;

  SR := ListBox1.ItemRect(ListBox1.ItemIndex);
  if odSelected in state then
    If PPED^.Kind = PeProp then            { Enumeration - Simulate List box. }
      If PI^.PropType^.kind = tkEnumeration then Begin
        ComboButtonBox := SR;
        SR.Right := SR.Right - ABS(SR.Bottom - SR.Top);
        Inc(comboButtonBox.Top,2);
        ComboButtonBox.Left := SR.right + 1;
        DrawButtonFace(Listbox1.canvas, ComboButtonBox, 3, bsnew,
          false, false, false);

{        R1.Left := 0;
        R1.Right := DownArrow.Width;
        r1.top := 0;
        R1.Bottom := DownArrow.Height;
}
{        Dr.Left := ComboButtonBox.Left +
          ((ComboButtonBox.Right - ComboButtonBox.Left) DIV 2) - (DownArrow.Width DIV 2);
        Dr.Right := DR.Left + DownArrow.Width;
        Dr.Top := ComboButtonBox.Top +
          ((ComboButtonBox.Bottom - ComboButtonBox.Top) DIV 2) - (DownArrow.Height DIV 2);
        DR.Bottom := DR.Top + DownArrow.Height;
}
        Dr.Left := ComboButtonBox.Left +
          ((ComboButtonBox.Right - ComboButtonBox.Left) DIV 2) - (7 DIV 2);
        Dr.Right := DR.Left + DownArrow.Width;
        Dr.Top := ComboButtonBox.Top +
          ((ComboButtonBox.Bottom - ComboButtonBox.Top) DIV 2) - (4 DIV 2);
        DR.Bottom := DR.Top + DownArrow.Height;

        ListBox1.Canvas.CopyRect(Dr, DownArrow.Canvas, DownArrow.Canvas.ClipRect);
//        ImageList1.Draw(Listbox1.canvas, ComboButtonBox.Left, Combobuttonbox.top, 0);
//        ListBox1.Canvas.BrushCopy(DR, DownArrow, R1, clOlive);

        Button1.visible := False;
      End;


  If (not edit1.focused) and (odselected in state) then
      With ListBox1.Canvas do Begin
      edit1.visible := false;
      EditRect := ListBox1.ItemRect(ListBox1.ItemIndex);
      EditRect.Left := HalfWay + 2;
      Brush.Color := clWhite;
      Inc(EditRect.Top,2);
      if PPED^.Kind = peProp then
      If PI^.PropType^.kind = tkEnumeration then
        EditRect.Right := EditRect.Right - ABS(EditRect.Bottom - EditRect.Top);
//      If PI^.PropType.Kind = tkClass then Begin
      If (PPED.Kind = peProp) and (PI^.proptype^.kind = tkclass) then
        if Assigned(o) then begin
          If IsRegistered(o) then Begin
            Button1.Width := EditRect.Bottom - EditRect.Top;
            EditRect.Right := EditRect.Right - ABS(EditRect.Bottom - EditRect.Top);
            Button1.Left := Editrect.Right + 1;
            Button1.Top := EditRect.Top;
            Button1.Height := EditRect.Bottom - EditRect.Top;
            Button1.Visible := true;
          End else button1.visible := false;
        End else button1.visible := false;
      Fillrect(EditRect);
      setbkColor(ListBox1.Canvas.Handle, GetsysColor(color_HighLight));
      setbkMode(ListBox1.Canvas.Handle, Opaque);
      Font.Color := clhighlightText;
      Canvas.Brush.Color := clHighlight;
      EdString := RString;
      If (PPED.Kind = peProp) and (PI^.PropType^.kind in
        [tkSet, tkEnumeration, tkClass]) then Edit1.readOnly := True
      else Edit1.ReadOnly := False;

      While (TextWidth(EdString) > (EditRect.Right - EditRect.Left)) and (EdString <> '')  do
        Delete(EdString,1,1);
      TextOut(EditRect.Left, EditRect.Top, edString);
      DestroyCaret;
      Createcaret(ListBox1.Handle, 0, 1, (EditRect.Bottom - Editrect.top) - 2);
      SetCaretPos(EditRect.Left + textWidth(EdString), editRect.Top+1);
      ShowCaret(Listbox1.handle);
      Edit1.Text := RString;
      End else Begin
        If (odSelected in state) and CBDown then Begin
          ListBox1.Canvas.Brush.Color := clWhite;
          listbox1.Canvas.FillRect(EditRect);
          Font.Color := clWindowText;
          If Edit1.Focused then RString := Edit1.text;
          (Control as TListbox).Canvas.TextOut(HalfWay + 2, Rect.Top+2, RString);
          End Else;
        (Control as TListbox).Canvas.TextOut(HalfWay + 2, Rect.Top, RString);
      End;
    if (odFocused in State) and (odselected in state) then
      (Control as TListbox).Canvas.DrawFocusRect(rect);

    If button1.visible then button1.refresh;
end;

             { This is an ugly one. }
procedure Tf_Inspector.ListBox1DblClick(Sender: TObject);
Var PD : PTypeData;
    PD1 : PTypeData;
    NewPPED : PPRopEditData;
    PS : ^ShortString;
    PPED : PPropEditData;
    X : Integer;
    Size : Integer;
    PL: PPropList;
    o : TObject;
    JP : Pointer;
    P : Tpoint;

  Procedure HideChildren(I : Integer);
  var
    PE : PPropEditData;
    X : integer;
    JP : Pointer;
    PE2 : PPropEditData;
  Begin
    PE := Pointer(ListBox1.Items.Objects[I]);
    If PE^.Kind = peSetItem then Exit;
    Case PE^.PropData^.PropType^.Kind of
      tkClass : JP := Pointer(getOrdProp(PE^.Ob, PE^.PI));
      tkSet   : JP := PE;
    End;
    If JP = Nil then exit;
      O := Tobject(JP);
    If PE^.ChildShowing then Begin
      PE^.childShowing := False;
      X := 0;
      While X < ListBox1.Items.Count do Begin
        if (PPropEditData(ListBox1.Items.Objects[x])^.Ob = O) then Begin
          PE2 := Pointer(ListBox1.Items.Objects[X]);
          If PE2^.ChildShowing then HideChildren(X);
          Freemem(Pointer(ListBox1.Items.Objects[x]), Sizeof(TPropEditData));
          ListBox1.Items.Delete(X);
          Dec(X);
        End;
        Inc(X);
      End;
   End;
 End;

begin
  GetCursorPos(P);
  MapWindowPoints(0, ListBox1.Handle, P, 1);
  PPED := Pointer(ListBox1.Items.Objects[ListBox1.ItemIndex]);
            { Handle clicks left of the break. }
             { Basically show or hide children properties. }
  If P.X < halfway then Begin
    if PPED^.Kind = peProp then Begin
      Case PPED^.PropData^.PropType^.Kind of
        tkClass : JP := Pointer(getOrdProp(PPED^.Ob, PPED^.PI));
        tkSet   : JP := PPED;
      End;
      If JP = Nil then exit;
       O := Tobject(JP);
       If PPED^.ChildShowing then Begin
         HideChildren(ListBox1.ItemIndex);
         Exit;
       End;

      Case PPED^.PropData^.PropType^.Kind of
        tkClass : Begin

          Size := GetTypeData(PPED^.PropData^.PropType^)^.Propcount;
          GetMem(PL, Size*SizeOf(Pointer));

          GetPropInfos(PPED^.PropData^.PropType^, PL);

          PPED^.ChildShowing := True;
          for X := 0 to Size-1 do
            if pl[x]^.proptype^.kind <> tkMethod then Begin
              GetMem(NewPPED, SizeOf(TPropEditData));
              NewPPED^.Ob := Tobject(GetOrdProp(PPED^.Ob, PPED^.PI));
              NewPPED^.Kind := peProp;
              NewPPED^.ChildShowing := False;
              NewPPED^.Depth := PPED^.Depth + 1;
              NewPPED^.PropData := pl[x];
              NewPPED^.Kind := peProp;
              ListBox1.Items.InsertObject(ListBox1.ItemIndex+1 + X ,
                                          '',TObject(newPPED));

            End;

          FreeMem(PL, Size * SizeOf(Pointer));
        End;
        tkSet : Begin
          PD := GetTypeData(PPED^.PropData^.PropType^);
          if PD^.CompType^.Kind = tkEnumeration then Begin
            PD1 := GetTypeData(PD^.CompType^);
            PPED^.ChildShowing := True;
            PS := @PD1^.NameList;
            For x := PD1^.MinValue to PD1^.MaxValue do Begin
              GetMem(NewPPED, SizeOf(TPropEditData));
              NewPPED^.Value := X;
              NewPPEd^.Name := PS^;
              Inc(Integer(PS), Length(PS^) + 1);
              NewPPED^.Depth := PPED^.Depth + 1;
              NewPPED^.Ob := Tobject(PPED);
              NewPPED^.PI := PPED^.PropData;
              NewPPED^.Kind := peSetItem;
              ListBox1.Items.InsertObject(ListBox1.ItemIndex+1 + (X - PD1^.MinValue),
                                          '',TObject(newPPED));
            End;
          End;
        End;
      End;
    End;          { Now handle clicks right of the divide. }
  End Else Begin
    If PPED^.kind = peprop then
      Case PPED^.PropData^.PropType^.Kind of
        tkClass : Begin
          JP := Pointer(getOrdProp(PPED^.Ob, PPED^.PI));
          If JP = Nil then exit;
          O := Tobject(JP);
          If IsRegistered(o) then
            Edit(o);
        End;
        tkEnumeration : Begin
          PPED := Pointer(ListBox1.Items.Objects[ListBox1.ItemIndex]);
          PD := GetTypeData(PPED^.PropData.PropType^);
          x := getOrdProp(PPED^.Ob, PPED^.PropData);
          Inc(x);
          if x > PD^.maxvalue then x := pd^.minvalue;
          SetOrdProp(PPED^.Ob, PPED^.Propdata, X);
        End;
      End Else Begin  { A set option. }
        If PPED^.Kind = peSetItem then
          SetOrdProp(PPropEditData(PPED^.Ob)^.Ob, PPED^.PI,
            GetOrdProp(PPropEditData(PPED^.Ob)^.Ob, PPED^.PI) XOR (1 shl PPED^.Value));
      End;
  End;
  ListBox1.SetFocus;
  ListBox1.Refresh;
end;
                           { these next three are just your stock split panel }
                          { handling routines.  There's some GDI optimization }
                                                        { to prevent flicker. }
procedure Tf_Inspector.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  MDX := X;
  If edit1.focused then listbox1.setfocus;
end;

procedure Tf_Inspector.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
Var NewX : Integer;
    R : TRect;
    TV1InvRegion : Integer;
begin
  if mdx = -1 then exit;
  LockWindowUpdate(handle);
  NewX := PaintBox1.Left + (X - MDX);
  if NewX < 40 then NewX := 40;
  If ClientWidth - (NewX + PaintBox1.Width) < 40 then Newx :=
    ClientWidth - PaintBox1.Width - 40;
  TV1InvRegion := (NewX - 1) - TreeView1.Width;
  TreeView1.Width := NewX - 1;
  If halfway > ListBox1.ClientWidth then halfway := listbox1.Clientwidth div 2;
  PaintBox1.Left := NewX;
  PageControl1.Width := ClientWidth - TreeView1.Width - PaintBox1.Width;
  PageControl1.Left := PaintBox1.Left + PaintBox1.Width;
  LockWindowUpdate(0);

  If X < MDX then
    validaterect(Treeview1.handle,Nil) Else Begin
    R.Left := 0;  R.Right := Treeview1.ClientWidth - TV1InvRegion-20;
    R.Top := 0;  R.Bottom := TreeView1.ClientHeight-20;
    validaterect(Treeview1.handle,@R); End;
  PaintBox1.RePaint;
end;

procedure Tf_Inspector.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  mdx := -1;
end;
Procedure tf_Inspector.WhileSizing(var msg : tmessage);
var PR : PRect;                              { Makes it so there's never half }
     Offset : Integer;                        { a row showing in the listbox. }
     Growing : Boolean;
     Top : Boolean;
     Lb : tlistbox;
Begin
  if PageControl1.ActivePage = TabSheet1 then Lb := ListBox1 else lb := listbox2;
  if not (msg.wparam in [wmsz_top, wmsz_topleft, wmsz_topright,
                         wmsz_bottom, wmsz_bottomleft, wmsz_bottomright]) then exit;
  pr := Pointer(msg.Lparam);
  if (pr.bottom - pr.top) = height then exit;
  msg.result:= 1;
  OffSet := ((pr.bottom - pr.top) - (height - Lb.clientheight)) mod lb.itemheight;
  Growing := (pr.bottom - pr.top) > height;
  top := msg.wparam in [wmsz_top, wmsz_topleft, wmsz_topright];

  if top then Begin
    if growing then
      pr.top := pr.top + offset
    else
      pr.top := pr.top - (lb.Itemheight - offset);
  End Else Begin
    if Growing then
      pr.bottom := pr.Bottom - offset
    else
      pr.bottom := pr.bottom + (lb.Itemheight - offset);
  End;
End;

procedure Tf_Inspector.FormResize(Sender: TObject);
begin
  treeView1.Width := ClientWidth - PageControl1.Width - paintBox1.Width;
  If TreeView1.Width < 40 then TreeView1.Width := 40;
  PageControl1.Left := TreeView1.Width + PaintBox1.Width;
  PageControl1.Width := ClientWidth - TreeView1.Width - PaintBox1.Width;
  If PageControl1.Width < 40 then PageControl1.Width := 40;
  PaintBox1.Left := TreeView1.Width;
  TreeView1.Height := ClientHeight;
  PaintBox1.Height := ClientHeight;
  PageControl1.Height := ClientHeight;
  If ClientWidth < TreeView1.Width + PaintBox1.Width + PageControl1.Width then
     ClientWidth := TreeView1.Width + PaintBox1.Width + PageControl1.Width;
end;

Procedure Tf_Inspector.IdleHandler;              { This updates the display. }
var r : trect;                                  { Set to application.OnIdle. }
    Inv : Boolean;
    x : integer;
Begin
  If (Time-LastPoll) > (1 / 24 / 60 / 60 / 5) then Begin


Try
  ListBox1.Visible := True;
Except
  ListBox1.Visible := False;
  Exit;
End;

  LastPoll := Time;
  r.left := HalfWay;  r.right := listbox1.ClientWidth;  r.bottom := ListBox1.clientHeight;
  r.top := 0;
  inv := false;
  For x := 0 to listbox1.items.count -1 do
    if SeeIfChanged(X) then begin
      inv := true;
      break;
    End;
  If inv then
  InvalidateRect(ListBox1.Handle, @r, false);
 End;
  If Assigned(Oldidlehandler) then OldIdleHandler(sender, done);
End;

procedure Tf_Inspector.FormShow(Sender: TObject);
Var I : TTreeNode;
    SI : Integer;
begin
  {$IFDEF Shareware }                            { Here's the shareware code. }
  Randomize;
  MaxObjects := random(75);
  WhateverBox := TWhateverBox.Create(self);
  WhateverBox.Label3.Caption := 'It will display ' + IntToStr(maxObjects) +
    ' components this time around.  (Redisplay it to genrate another random number.)';
  WhateverBox.ShowModal;
  WhateverBox.Free;
  {$ENDIF }

  if assigned(ti) then
  if (ti is tInspector) then
  parentobject := TComponent((TI as TInspector).MainParent) else
  parentobject := Application;

  Height := Height + ListBox1.ClientHeight mod ListBox1.ItemHeight;
  LastPoll := Time;
  OldIdlehandler := Application.OnIdle;
  Application.OnIdle := IdleHandler;
  Halfway := ListBox1.Width div 2;
  Treeview1.Items.Clear;
  if parentObject is tApplication then
    i := treeView1.Items.AddObject(treeView1.Items.GetFirstNode, lowerCase(ExtractFileName(Application.ExeName)), ParentObject)
  else
    I := TreeView1.Items.AddObject(TreeView1.Items.GetFirstNode, ParentObject.Name, ParentObject);
//  I := TreeView1.Items.AddObject(TreeView1.Items.GetFirstNode, 'Application', Application);
//  SI := AssignIcon(Application);
  SI := AssignIcon(Parentobject);
  I.imageIndex := si;
  I.SelectedIndex := si;
  ShowAll(I);
end;

procedure Tf_Inspector.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var P : TPoint;
      R,sr : TRect;
    PPED : PPropEditData;
Var PI : PPropInfo;
    PTD : PTypeData;
begin
  If Abs(x - Halfway) <= 3 then
    SplitDrag := True
  else
  If (X >= EditRect.left) and (X <= EditRect.Right) and
     (y >= EditRect.Top) and (Y <= EditRect.Bottom) then Begin
     P.X := x;
     p.y := y;
     ListBox1.Cursor := crDefault;
     Edit1.left := EditRect.left;
     Edit1.Top := EditRect.Top;
     Edit1.Width := EditRect.Right - EditRect.Left;
     edit1.Height := EditRect.Bottom - EditRect.Top;
     Edithit := Time;
     fromListBox := True;
     Edit1.Visible := True;
     MapWindowPoints(ListBox1.Handle, Edit1.Handle, P, 1);
     PostMessage(Edit1.handle, WM_LButtonDown, mk_lbutton, p.y shl 16 + p.x);
  End Else
     If (X >= ComboButtonBox.left) and (X <= ComboButtonBox.Right) and
        (y >= ComboButtonBox.Top) and (Y <= ComboButtonBox.Bottom) and
        (not CBDown) then Begin
        PPED := Pointer(ListBox1.Items.Objects[ListBox1.ItemIndex]);
        PI := PPED^.PropData;
        PTD := GetTypeData(PI^.PropType^);
        CBDown := True;
        R.Left := EditRect.Left;
        R.Right := ComboButtonBox.Right;
        R.Top := EditRect.Bottom;
        ListScreen.ListBox1.Items.Clear;
        For x := PTD^.MinValue to PTD^.maxValue do
          ListScreen.ListBox1.Items.Add(GetEnumname(PI^.PropType^, X));
        If ListScreen.ListBox1.Items.Count > 6 then
          R.Bottom := R.Top + (ListScreen.ListBox1.Itemheight *  6)
        else
          R.Bottom := R.Top + (ListScreen.ListBox1.Itemheight *
            ListScreen.ListBox1.Items.Count);

        R.TopLeft := ListBox1.ClientToScreen(R.TopLeft);
        R.BottomRight := ListBox1.ClientToScreen(R.BottomRight);

        ListScreen.Left := R.Left;
        ListScreen.Width := R.Right - R.Left;
        ListScreen.Top := R.Top - ListBox1.Itemheight +2;
        ListScreen.Height := R.Bottom - R.Top + ListBox1.ItemHeight;

        R := EditRect;

        R.right := ComboButtonBox.Right;

        ListScreen.Listbox1.Top := ListBox1.ItemHeight - 2;
        ListScreen.ListBox1.Height := ListScreen.clientHeight -
          (R.Bottom-R.Top);
        ListScreen.ListBox1.Left := 0;
        ListScreen.ListBox1.Width := ListScreen.ClientWidth;

        ListScreen.UnderNeath := TBitmap.Create;

        ListScreen.UnderNeath.Height := R.Bottom-R.Top;
        ListScreen.UnderNeath.Width :=  R.Right - R.Left;

        Sr.left := 0;
        SR.Top := 0;
        Sr.Right := R.Right - R.Left;
        SR.bottom := R.Bottom - R.Top;

        ListScreen.Underneath.Canvas.CopyRect(SR, ListBox1.canvas, R);
        ListScreen.Show;
    End;
end;

procedure Tf_Inspector.ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);                 { handles dragging the split in the two panes. }
Var TempR : TRect;
    Var LB : TListBox;
begin
  if PageControl1.ActivePage = TabSheet1 then Lb := ListBox1 else lb := listbox2;
  If SplitDrag then Begin
    If X > Lb.ClientWidth - 20 then X :=
      Lb.ClientWidth - 20;
    If X < 20 then X := 20;

    If Halfway < x then Begin
      TempR.Left := Halfway;  TempR.Right := lb.ClientWidth;
      TempR.Top := 0;  TempR.Bottom := lb.ClientHeight;
    End Else Begin
    TempR.Left := X;  TempR.Right := lb.ClientWidth;
      TempR.Top := 0;  TempR.Bottom := lb.ClientHeight;
    End;
    HalfWay := x;

    InvalidateRect(lb.Handle, @tempR, false);

    InvalidateRect(lb.Handle, @EditRect, False);
    PostMessage(lb.Handle, WM_Paint, 0, 0);
    Exit;
  End;
  If Abs(x - Halfway) <= 3 then
    lb.Cursor := crHSplit
  Else
  If (X >= EditRect.left) and (X <= EditRect.Right) and
     (y >= EditRect.Top) and (Y <= EditRect.Bottom) then
       lb.Cursor := crIBeam else lb.Cursor := crDefault;
End;

procedure Tf_Inspector.ListBox2DblClick(Sender: TObject);
Var PED : PEventData;
begin
  PED := pointer(ListBox2.Items.Objects[ListBox2.ItemIndex]);
  If PED.M.Code = Nil then exit;
  if PED.Enabled then begin
    AddEvent(Treeview1.Selected.Data, PED^.PI, PED^);
    SetmethodProp(TreeView1.Selected.Data, PED.PI, UnAssignedEvent)
  End else Begin
    DeleteEvent(Treeview1.Selected.Data, PED^.PI);
    SetmethodProp(TreeView1.Selected.Data, PED^.PI, PED^.M);
  End;
  PED.Enabled := Not(PED.Enabled);
  ListBox2.Items.Strings[ListBox2.ItemIndex] := '';
End;

procedure Tf_Inspector.Button1Click(Sender: TObject);
begin
  ListBox1DblClick(Sender);
end;


procedure Tf_Inspector.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);                        { to route keypresses properly. }

begin
  If key = vk_return then Begin
    Key := 0;
        exit;
  End;
  If not (key in [vk_up, vk_down, vk_prior, vk_next]) then begin
    Edit1.left := EditRect.left;
    Edit1.Top := EditRect.Top;
    Edit1.Width := EditRect.Right - EditRect.Left;
    Edit1.Height := EditRect.Bottom - EditRect.Top;
    Edit1.Visible := True;
    Edit1.SetFocus;
    PostMessage(Edit1.Handle, WM_KeyDown, key, 0);
    key := 0;
  End;
end;

procedure Tf_Inspector.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);                        { to route keypresses properly. }
begin
  If Key = vk_Return then Begin
    ListBox1.SetFocus;
    key := 0;
    Exit;
  End;
  If (key in [vk_up, vk_down, vk_prior, vk_next]) then begin
    Listbox1.Setfocus;
    PostMessage(ListBox1.Handle, WM_KeyDown, key, 0);
    Key := 0;
  End;
end;

procedure Tf_Inspector.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
//  Free;
//    ListScreen.Destroy;
end;

Procedure Tf_Inspector.NewKeyEvent(Sender : TObject; Var Key : Word; Shift : TShiftState);
Var skey : Word;
   sShift : tShiftState;
   var b : boolean;
Begin
  If not assigned(lastform) then exit;
  ShortCutToKey(hotKey, sKey, sShift);
  if (Key = sKey) and (shift = sShift)
  then Begin
    if assigned(beforeshow) then begin
      b := true;
      BeforeShow(self, b);
      if not b then exit;
    end;
    If Not Assigned(self) then self := tf_Inspector.Create(Application{, self});
    Self.Show;
  end;
  If Assigned(OldKeyEvent) then OldKeyEvent(Sender, Key, Shift);
End;

Procedure Tf_Inspector.NewFormhandler(Sender : TObject);   { This gets called }
Begin                                                  { when the ActiveForm  }
  If Assigned(LastForm) then Begin                                 { changes. }
    LastForm.OnKeyDown := OldKeyEvent;
    LastForm.KeyPreview := OldKeyPreview;
  End;
  If Screen.ActiveForm = Nil then exit;
  LastForm := Screen.ActiveForm;
  OldKeyPreview := lastForm.KeyPreview;
  lastForm.KeyPreview := True;
  If Not Assigned(Lastform) then exit;
  OldKeyEvent := LastForm.OnKeyDown;
  LastForm.OnKeyDown := NewKeyEvent;
  if Assigned(OldFormhandler) then OldFormHandler(Sender);
End;

function GetShiftState: TShiftState;
begin
  Result := [];
  if GetKeyState(VK_SHIFT) < 0 then Include(Result, ssShift);
  if GetKeyState(VK_CONTROL) < 0 then Include(Result, ssCtrl);
  if GetKeyState(VK_MENU) < 0 then Include(Result, ssAlt);
end;


procedure KbHook(code : integer;  wParam : word;  lParam : integer);   stdcall;
Var skey : Word;
   sShift : tShiftState;
   var b : boolean;
   self : Tf_Inspector;
   shift : tShiftState;
Begin
  self := hookedInspector;
  shift := getShiftState;
//  If not assigned(lastform) then exit;
  ShortCutToKey(self.hotKey, sKey, sShift);
  if (wParam = sKey) and (shift = sShift)
  then Begin
    if assigned(self.beforeshow) then begin
      b := true;
      self.BeforeShow(self, b);
      if not b then exit;
    end;
    If Not Assigned(self) then self := tf_Inspector.Create(Application{, self});
    Self.Show;
  end;

  callnextHookEx(hHook, code, wparam, lparam);
//  If Assigned(OldKeyEvent) then OldKeyEvent(Sender, Key, Shift);
End;



procedure Tf_Inspector.AutoStart;
Begin
  hookedInspector := self;
  hHook := SetWindowsHookEx(WH_KEYBOARD, @kbHook, 0, getCurrentThreadid);
  exit;
  if autostarted then exit;
  autostarted := true;
//  OldFormHandler := Screen.OnActiveFormChange;
//  Screen.OnActiveFormChange := NewFormHandler;
//  LastForm := Nil;
//  NewFormHandler(self);
End;

Procedure Tf_Inspector.EndAutoStart;
Begin
  UnhookWindowsHookEx(hHook);
  If not autostarted then exit;

//  LastForm.KeyPreview := OldkeyPreview;
//  LastForm.OnKeyDown := OldKeyEvent;
//  Screen.OnActiveFormChange := OldFormHandler;
//  If Assigned(LastForm) then LastForm.OnKeyDown := OldKeyEvent;
End;
procedure Tf_Inspector.Edit1Exit(Sender: TObject);      { Tries to update the }
Var PPED : PPropEditData;             { property to what was entered into the }
    X : Integer;                                                  { edit box. }
    NewInt : Integer;
    NewReal : Real;
begin
  If Edit1.Modified then Begin
  PPED := Pointer(ListBox1.Items.Objects[ListBox1.ItemIndex]);
  If PPED^.Kind = peProp then
    Case PPED^.PropData^.PropType^.Kind of
      tkInteger : Begin
          Val(Edit1.text, NewInt, X);
          if x = 0 then
            SetOrdProp(PPED^.Ob, PPED^.PropData, NewInt)
          Else Messagebeep(0);
        End;
      tkFloat : Begin
          Val(Edit1.text, NewReal, X);
          if x = 0 then
            SetFloatProp(PPED^.Ob, PPED^.PropData, NewReal)
          Else Messagebeep(0);
        End;
      tkEnumeration : Begin
          x := GetEnumValue(PPED^.PropData^.PropType^, Edit1.Text);
          if x  <> -1 then
            SetOrdProp(PPED^.Ob, PPED^.PropData, X)
          else Messagebeep(0);
        End;
      tkString, tkLString, tkWString :
          SetStrProp(PPED^.Ob, PPED^.PropData, Edit1.Text);
    End
  Else
    Messagebeep(0);
  end;
End;

procedure Tf_Inspector.ListBox1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SplitDrag := False;
end;

procedure Tf_Inspector.FormHide(Sender: TObject);
begin
  Application.OnIdle := OldIdlehandler;                   { For auto refresh. }
end;

procedure Tf_Inspector.Edit1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  If FromListBox then begin
    fromlistbox := false;
    exit;
  end;                                       { Have to simulate double click. }
  If (Time - EditHit) < (0.55 * (24 / 60 / 60 / 60))  then Begin
    ListBox1DblClick(self);
    edithit := 0;
  end;
end;

procedure Tf_Inspector.TreeView1Expanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
begin                                             { look for the dummy node - }
  If Node.GetFirstChild.Text = 'Dummy12345' then Begin       { and delete it. }
    try
      treeView1.items.BeginUpdate;
      Node.GetFirstChild.Delete;
      if Tcomponent(Node.Data) is tApplication then
        ShowAll(Node)
      else
        ShowChildren(Tcomponent(Node.Data), Node);
    finally
      treeView1.items.EndUpdate;
    end;
  End;
end;

procedure Tf_Inspector.TreeView1Collapsing(Sender: TObject;
  Node: TTreeNode; var AllowCollapse: Boolean);

Procedure DeleteChildren(N : TTreeNode);{ This recursively deletes a tree node }
var n1,n2 : ttreenode;                                    { and it's children. }

Begin
  N1 := N.GetFirstChild;
  While N1 <> Nil do begin
    DeleteChildren(N1);
    N2 := N.GetNextChild(N1);
    N1.Delete;
    n1 := n2;
  End;
End;

begin

{  If Node.Text = 'Application' then exit;     }
  try
    treeView1.items.BeginUpdate;
    DeleteChildren(Node);
    TreeView1.Items.AddChild(Node, 'Dummy12345');{ The dummy node keeps the '+' }
                                        { sign visible so you can drop down the }
                                                         { components children. }
  finally
    treeview1.items.EndUpdate;
  end;
end;

procedure Tf_Inspector.ListBox2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  If Abs(x - Halfway) <= 3 then
    SplitDrag := True;                              { Tell it we're dragging. }
end;

procedure Tf_Inspector.TreeView1DblClick(Sender: TObject);
var c : tcomponent;

begin
C := TComponent(Treeview1.Selected.Data);

Try
  ListBox1.Visible := True;
Except
  ListBox1.Visible := False;
  Exit;
End;
If IsRegistered(C) then Edit(C);
end;

Function tf_inspector.LocateComp(C : TComponent) : ttreeNode;
var MyResult : TTreeNode;

Procedure LookForComp(N : TTreeNode);
var n1,n2 : ttreenode;

Begin
  if n.data = C then begin
    MyResult := n;
    exit;
  end;

  N1 := N.GetFirstChild;
  While N1 <> Nil do begin
    LookForComp(N1);
    N1 := N.GetNextChild(N1);
  End;
End;

begin
  Myresult := nil;
  LookForComp(Treeview1.Items[0]);
  Result := MyResult;
End;

procedure tf_inspector.InsertComp(C, Parent : TComponent);
var
n : ttreenode;
si : integer;
begin
  if not visible then exit;
  n := locatecomp(parent);
  if assigned(n) then begin
    n := TreeView1.Items.AddChildObject(N, C.Name, C);
    SI := AssignIcon(C);
    n.imageIndex := si;
    n.SelectedIndex := si;
    If C.ComponentCount > 0 then
    TreeView1.Items.AddChild(N, 'Dummy12345');
    treeView1.Selected := N;
  end;
end;

procedure tf_inspector.SelectComp(C : TComponent);
begin
  if not visible then exit;
  treeview1.selected := LocateComp(C);
end;

end.


